class com.neodelight.game.Score
{
   var flow;
   var config;
   var sharedObject;
   var scoreTotal;
   var scores;
   var scoreLevel;
   function Score(config)
   {
      _global.bin.syslog("Score","new Score()");
      this.flow = new com.neodelight.std.Flow();
      if(!config)
      {
         config = Array(com.neodelight.std.Blueprint.getBlueprint("score").scoreTypes);
      }
      if(!config)
      {
         _global.bin.syslog("Score","constructor needs config",3);
      }
      else
      {
         this.config = config;
         var _loc4_ = 0;
         while(_loc4_ < config.length)
         {
            this.config[config[_loc4_].id] = config[_loc4_];
            this.config[_loc4_].i = _loc4_;
            _loc4_ = _loc4_ + 1;
         }
         this.sharedObject = SharedObject.getLocal(_global.game.name);
         this.reset();
      }
      if(_global.mdm)
      {
         _global.mdm.enableexithandler();
         com.neodelight.std.File.load(_global.game.name + ".stats",function(data)
         {
            if(!data)
            {
               _global.bin.syslog("Score","loaded external scores: empty");
               return undefined;
            }
            _global.bin.syslog("Score","loaded external scores (" + data.length + " bytes)");
            _root.decryptedScores = "";
            _global.mdm.blowfishdec("com.neodelight.game.Score",data,"_root.decryptedScores");
            _root.scoresLoadFlow = new com.neodelight.std.Flow();
            _root.scoresLoadFlow.pushTask(function()
            {
               if(_root.decryptedScores)
               {
                  _global.bin.syslog("Score","decrypted scores");
                  _global.score.sharedObject = {};
                  _global.score.sharedObject.data = com.neodelight.wddx.Wddx.deserialize(_root.decryptedScores);
                  delete _root.decrytpedScores;
                  return true;
               }
               return false;
            }
            ,undefined,undefined,undefined,true,true);
         }
         );
         _root.onAppExit = function()
         {
            var _loc4_ = _global.score.sharedObject.data;
            var _loc3_ = com.neodelight.wddx.Wddx.serialize(_loc4_);
            _root.encryptedScores = "";
            _global.mdm.blowfishenc("com.neodelight.game.Score",_loc3_,"encryptedScores");
            _root.appExitFlow = new com.neodelight.std.Flow();
            _root.appExitFlow.pushTask(function()
            {
               if(_root.encryptedScores)
               {
                  com.neodelight.mdm.MdmFile.save(_global.game.name + ".stats",_root.encryptedScores);
                  _global.mdm.exit();
                  return true;
               }
               return false;
            }
            ,undefined,undefined,undefined,true,true);
         };
      }
   }
   function reset()
   {
      _global.bin.syslog("Score","reset scores!");
      this.scoreTotal = 0;
      this.scores = new Object();
   }
   function initLevel()
   {
      _global.bin.syslog("Score","initLevel: " + _global.game.actLevel);
      this.scores[_global.game.actLevel] = new Object();
      var _loc3_ = 0;
      while(_loc3_ < this.config.length)
      {
         this.scores[_global.game.actLevel][this.config[_loc3_].id] = com.neodelight.std.XMath.toNumber(this.config[_loc3_].score);
         _loc3_ = _loc3_ + 1;
      }
      this.scoreLevel = 0;
   }
   function alter(deltaScore, type)
   {
      _global.bin.syslog("Score","alter \'" + type + "\' (" + deltaScore + ", type)");
      if(this.config[type].totalAdd)
      {
         this.scoreTotal += deltaScore;
         this.scoreLevel += deltaScore;
      }
      this.scores[_global.game.actLevel][type] += deltaScore;
   }
   function §set§(score, type)
   {
      _global.bin.syslog("Score","set \'" + type + "\' (" + score + ")");
      if(this.config[type].totalAdd)
      {
         this.scoreTotal -= com.neodelight.std.XMath.toNumber(this.scores[_global.game.actLevel][type]);
         this.scoreTotal += score;
      }
      this.scores[_global.game.actLevel][type] = score;
   }
   function §get§(type, level)
   {
      if(level == undefined)
      {
         level = _global.game.actLevel;
      }
      return this.scores[level][type];
   }
   function refresh()
   {
      trace("score:refresh");
      this.scoreTotal = 0;
      for(var _loc3_ in this.scores)
      {
         trace("level: " + _loc3_);
         var _loc2_ = 0;
         while(_loc2_ < this.config.length)
         {
            trace("t: " + _loc2_ + " id:" + this.config[_loc2_].id + " val:" + this.scores[_loc3_][this.config[_loc2_].id]);
            if(this.config[_loc2_].totalAdd)
            {
               this.scoreTotal += this.scores[_loc3_][this.config[_loc2_].id];
            }
            _loc2_ = _loc2_ + 1;
         }
      }
   }
   function saveType(disciple)
   {
      _global.bin.syslog("Score","saveType: " + disciple);
      var _loc4_ = _global.game.actLevel;
      _global.bin.syslog("Score","level = " + _loc4_);
      var _loc3_ = this.sharedObject.data;
      if(!_loc3_)
      {
         trace("#ERROR: no sObj");
      }
      if(!_loc3_.scores)
      {
         _loc3_.scores = new Object();
      }
      if(!_loc3_.scores[_loc4_])
      {
         _global.bin.syslog("Score","creating level object");
         _loc3_.scores[_loc4_] = new Object();
      }
      var _loc6_ = this.scores[_loc4_][this.config[disciple].id];
      _global.bin.syslog("Score","score = " + _loc6_);
      if(!_loc3_.scores[_loc4_][disciple])
      {
         _loc3_.scores[_loc4_][disciple] = new Object();
      }
      _loc3_.scores[_loc4_][disciple].count = int(_loc3_.scores[_loc4_][disciple].count) + 1;
      if(_loc3_.scores[_loc4_][disciple].max == undefined || _loc3_.scores[_loc4_][disciple].max < _loc6_)
      {
         _loc3_.scores[_loc4_][disciple].max = _loc6_;
      }
      if(_loc3_.scores[_loc4_][disciple].min == undefined || _loc3_.scores[_loc4_][disciple].min > _loc6_)
      {
         _loc3_.scores[_loc4_][disciple].min = _loc6_;
      }
      if(_loc3_.scores[_loc4_][disciple].avg == undefined)
      {
         _loc3_.scores[_loc4_][disciple].avg = _loc6_;
      }
      else
      {
         _loc3_.scores[_loc4_][disciple].avg = (_loc3_.scores[_loc4_][disciple].avg * (_loc3_.scores[_loc4_][disciple].count - 1) + _loc6_) / _loc3_.scores[_loc4_][disciple].count;
      }
   }
   function save(saveTotal)
   {
      _global.bin.syslog("Score","save");
      var _loc4_ = this.sharedObject.data;
      if(saveTotal)
      {
         _loc4_.count = int(_loc4_.count) + 1;
         if(_loc4_.max == undefined || _loc4_.max > this.scoreTotal)
         {
            _loc4_.max = this.scoreTotal;
         }
         if(_loc4_.min == undefined || _loc4_.min < this.scoreTotal)
         {
            _loc4_.min = this.scoreTotal;
         }
         _loc4_.avg = _loc4_.avg != undefined ? (_loc4_.avg * (_loc4_.count - 1) + this.scoreTotal) / _loc4_.count : this.scoreTotal;
      }
      if(!_loc4_.scores)
      {
         _loc4_.scores = new Object();
      }
      var _loc5_ = _global.game.actLevel;
      if(!_loc4_.scores[_loc5_])
      {
         _loc4_.scores[_loc5_] = new Object();
      }
      var _loc3_ = 0;
      while(_loc3_ < this.config.length)
      {
         var _loc6_ = this.scores[_loc5_][this.config[_loc3_].id];
         if(!_loc4_.scores[_loc5_][_loc3_])
         {
            _loc4_.scores[_loc5_][_loc3_] = new Object();
         }
         _loc4_.scores[_loc5_][_loc3_].count = int(_loc4_.scores[_loc5_][_loc3_].count) + 1;
         if(_loc4_.scores[_loc5_][_loc3_].max == undefined || _loc4_.scores[_loc5_][_loc3_].max < _loc6_)
         {
            _loc4_.scores[_loc5_][_loc3_].max = _loc6_;
         }
         if(_loc4_.scores[_loc5_][_loc3_].min == undefined || _loc4_.scores[_loc5_][_loc3_].min > _loc6_)
         {
            _loc4_.scores[_loc5_][_loc3_].min = _loc6_;
         }
         if(_loc4_.scores[_loc5_][_loc3_].avg == undefined)
         {
            _loc4_.scores[_loc5_][_loc3_].avg = _loc6_;
         }
         else
         {
            _loc4_.scores[_loc5_][_loc3_].avg = (_loc4_.scores[_loc5_][_loc3_].avg * (_loc4_.scores[_loc5_][_loc3_].count - 1) + _loc6_) / _loc4_.scores[_loc5_][_loc3_].count;
         }
         _loc3_ = _loc3_ + 1;
      }
   }
   function getStatistics()
   {
      _global.bin.syslog("Score","getStatistics",0);
      var _loc5_ = this.sharedObject.data;
      var _loc4_ = new Object();
      _loc4_.scores = new Object();
      _loc4_.avg = _loc5_.avg;
      _loc4_.max = _loc5_.max;
      _loc4_.cur = _loc5_.cur;
      _loc4_.count = _loc5_.count;
      for(var _loc6_ in _loc5_.scores)
      {
         _loc4_.scores[_loc6_] = new Object();
         var _loc3_ = 0;
         while(_loc3_ < this.config.length)
         {
            _loc4_.scores[_loc6_][this.config[_loc3_].id] = new Object();
            _loc4_.scores[_loc6_][this.config[_loc3_].id].avg = _loc5_.scores[_loc6_][this.config[_loc3_].id].avg;
            _loc4_.scores[_loc6_][this.config[_loc3_].id].min = _loc5_.scores[_loc6_][this.config[_loc3_].id].min;
            _loc4_.scores[_loc6_][this.config[_loc3_].id].max = _loc5_.scores[_loc6_][this.config[_loc3_].id].max;
            _loc4_.scores[_loc6_][this.config[_loc3_].id].count = _loc5_.scores[_loc6_][this.config[_loc3_].id].count;
            _loc4_.scores[_loc6_][this.config[_loc3_].id].cur = this.scores[_loc6_][this.config[_loc3_].id];
            _loc3_ = _loc3_ + 1;
         }
      }
      return _loc4_;
   }
   function clearSharedObject()
   {
      _global.bin.syslog("Score","clearSharedObject",1);
      this.sharedObject.clear();
      this.sharedObject.data = new Object();
   }
}
