class com.neodelight.std.Vector
{
   var x;
   var y;
   function Vector(x, y)
   {
      this.x = x;
      this.y = y;
   }
   function copyOf()
   {
      return new com.neodelight.std.Vector(this.x,this.y);
   }
   function toString()
   {
      return "{x:" + this.x + ", y:" + this.y + "}";
   }
   static function intersectP(ax0, ay0, ax1, ay1, bx0, by0, bx1, by1)
   {
      var _loc3_ = ax0 - bx0;
      var _loc2_ = ay0 - by0;
      var _loc1_ = by1 * ax1 - bx1 * ay1;
      if(_loc1_ == 0)
      {
         return undefined;
      }
      var _loc4_ = by1 * _loc3_ - bx1 * _loc2_;
      return -1 * _loc4_ / _loc1_;
   }
   static function splitP(ax, ay, bx, by)
   {
      return (bx * ax - by * ay) / ((- bx) * bx - by * by);
   }
   static function splitV(a, b)
   {
      return ((- b.x) * a.x - b.y * a.y) / (b.x * (- b.x) - b.y * b.y);
   }
   static function normalizeP(vx, vy)
   {
      var _loc1_ = Math.sqrt(vx * vx + vy * vy);
      return new com.neodelight.std.Vector(vx / _loc1_,vy / _loc1_);
   }
   static function normalizeV(v)
   {
      var _loc2_ = Math.sqrt(v.x * v.x + v.y * v.y);
      v.x /= _loc2_;
      v.y /= _loc2_;
      return v;
   }
   static function magnitudeP(vx, vy)
   {
      return Math.sqrt(vx * vx + vy * vy);
   }
   static function magnitudeV(v)
   {
      return Math.sqrt(v.x * v.x + v.y * v.y);
   }
   static function distanceP(px, py, v0x, v0y, v1x, v1y)
   {
      var _loc3_ = Math.sqrt(v1x * v1x + v1y * v1y);
      v1x /= _loc3_;
      v1y /= _loc3_;
      return -1 * ((v1x * (py - v0y) - v1y * (px - v0x)) / (v1x * v1x + v1y * v1y));
   }
   static function distanceV(p, v0, v1)
   {
      var _loc2_ = v1.x;
      var _loc1_ = v1.y;
      var _loc3_ = Math.sqrt(_loc2_ * _loc2_ + _loc1_ * _loc1_);
      _loc2_ /= _loc3_;
      _loc1_ /= _loc3_;
      return -1 * ((_loc2_ * (p.y - v0.y) - _loc1_ * (p.x - v0.x)) / (_loc2_ * _loc2_ + _loc1_ * _loc1_));
   }
}
